<template>
  <div class="grid grid-item">
    <div
      :class="{ invalid: v$.itemForm.name.$error }"
      class="input-wrapper item-name"
    >
      <label for="item-name">Item Name</label>
      <base-input
        type="text"
        id="item-name"
        name="item-name"
        @blur="v$.itemForm.name.$touch"
        v-model="itemForm.name"
      ></base-input>
    </div>
    <div
      :class="{ invalid: v$.itemForm.quantity.$error }"
      class="input-wrapper"
    >
      <label for="qty">Qty.</label>
      <base-input
        type="number"
        min="0"
        id="qty"
        name="qty"
        @blur="v$.itemForm.quantity.$touch"
        v-model="itemForm.quantity"
      ></base-input>
    </div>
    <div :class="{ invalid: v$.itemForm.price.$error }" class="input-wrapper">
      <label for="price">Price</label>
      <base-input
        type="number"
        min="0"
        id="price"
        name="price"
        @blur="v$.itemForm.price.$touch"
        v-model="itemForm.price"
      ></base-input>
    </div>
    <div class="input-wrapper">
      <label for="total">Total</label>
      <base-input
        disabled
        type="text"
        id="total"
        name="total"
        v-model="total"
      ></base-input>
    </div>
    <div class="input-wrapper delete-item">
      <base-button
        mode="delete-icon"
        class="btn-delete-item"
        @click="deleteItem"
      >
        <img src="@/assets/icon-delete.svg" />
      </base-button>
    </div>
  </div>
</template>
<script>
import { useVuelidate } from "@vuelidate/core";
import { required } from "@vuelidate/validators";

export default {
  emits: ["delete-item"],
  setup: () => ({ v$: useVuelidate({ $lazy: true, $autoDirty: true }) }),
  props: {
    item: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      itemForm: this.item,
    };
  },
  computed: {
    total() {
      return this.item.price * this.item.quantity;
    },
  },
  watch: {
    total() {
      this.itemForm.total = this.item.price * this.item.quantity;
    },
  },
  validations() {
    return {
      itemForm: {
        name: {
          required,
        },
        quantity: {
          required,
        },
        price: {
          required,
        },
      },
    };
  },
  methods: {
    deleteItem() {
      this.$emit("delete-item", this.itemForm.id);
    },
  },
};
</script>
<style scoped>
label {
  color: hsl(var(--clr-text-form-label));
}
.grid-item {
  grid-template-columns: 1fr 2fr 1fr max-content;
}
.item-name {
  grid-column: 1/5;
}
@media (min-width: 56.25em) {
  .item-name {
    grid-column: 1;
  }
  .grid-item {
    grid-template-columns: 3fr 1fr 2fr 1fr max-content;
  }
}
.delete-item {
  align-self: end;
}
.btn-delete-item {
  margin-left: auto;
}
</style>
